#ifndef N64_ADDRESSES_H
#define N64_ADDRESSES_H

#define SREGION_RDRAM           0x00000000
#define SREGION_RDRAM_UNUSED    0x00800000
#define SREGION_RDRAM_REGS      0x03F00000
#define SREGION_SP_MEM          0x04000000
// Overlaps with SREGION_SP_MEM above
#define SREGION_SP_DMEM         0x04000000
#define SREGION_SP_IMEM         0x04001000
#define SREGION_SP_REGS         0x04040000
#define SREGION_DP_COMMAND_REGS 0x04100000
#define SREGION_DP_SPAN_REGS    0x04200000
#define SREGION_MI_REGS         0x04300000
#define SREGION_VI_REGS         0x04400000
#define SREGION_AI_REGS         0x04500000
#define SREGION_PI_REGS         0x04600000
#define SREGION_RI_REGS         0x04700000
#define SREGION_SI_REGS         0x04800000
#define SREGION_UNUSED          0x04900000
#define SREGION_CART_2_1        0x05000000
#define SREGION_CART_1_1        0x06000000
#define SREGION_CART_2_2        0x08000000
#define SREGION_CART_1_2        0x10000000
#define SREGION_PIF_BOOT        0x1FC00000
#define SREGION_PIF_RAM         0x1FC007C0
#define SREGION_RESERVED        0x1FC00800
#define SREGION_CART_1_3        0x1FD00000
#define SREGION_SYSAD_DEVICE    0x80000000

#define EREGION_RDRAM           0x007FFFFF
#define EREGION_RDRAM_UNUSED    0x03EFFFFF
#define EREGION_RDRAM_REGS      0x03FFFFFF
#define EREGION_SP_MEM          0x0403FFFF
#define EREGION_SP_REGS         0x040FFFFF
#define EREGION_DP_COMMAND_REGS 0x041FFFFF
#define EREGION_DP_SPAN_REGS    0x042FFFFF
#define EREGION_MI_REGS         0x043FFFFF
#define EREGION_VI_REGS         0x044FFFFF
#define EREGION_AI_REGS         0x045FFFFF
#define EREGION_PI_REGS         0x046FFFFF
#define EREGION_RI_REGS         0x047FFFFF
#define EREGION_SI_REGS         0x048FFFFF
#define EREGION_UNUSED          0x04FFFFFF
#define EREGION_CART_2_1        0x05FFFFFF
#define EREGION_CART_1_1        0x07FFFFFF
#define EREGION_CART_2_2        0x0FFFFFFF
#define EREGION_CART_1_2        0x1FBFFFFF
#define EREGION_PIF_BOOT        0x1FC007BF
#define EREGION_PIF_RAM         0x1FC007FF
#define EREGION_RESERVED        0x1FCFFFFF
#define EREGION_CART_1_3        0x7FFFFFFF
#define EREGION_SYSAD_DEVICE    0xFFFFFFFF

#define REGION_RDRAM           SREGION_RDRAM           ... EREGION_RDRAM
#define REGION_RDRAM_UNUSED    SREGION_RDRAM_UNUSED    ... EREGION_RDRAM_UNUSED
#define REGION_RDRAM_REGS      SREGION_RDRAM_REGS      ... EREGION_RDRAM_REGS
#define REGION_SP_MEM          SREGION_SP_MEM          ... EREGION_SP_MEM
#define REGION_SP_REGS         SREGION_SP_REGS         ... EREGION_SP_REGS
#define REGION_DP_COMMAND_REGS SREGION_DP_COMMAND_REGS ... EREGION_DP_COMMAND_REGS
#define REGION_DP_SPAN_REGS    SREGION_DP_SPAN_REGS    ... EREGION_DP_SPAN_REGS
#define REGION_MI_REGS         SREGION_MI_REGS         ... EREGION_MI_REGS
#define REGION_VI_REGS         SREGION_VI_REGS         ... EREGION_VI_REGS
#define REGION_AI_REGS         SREGION_AI_REGS         ... EREGION_AI_REGS
#define REGION_PI_REGS         SREGION_PI_REGS         ... EREGION_PI_REGS
#define REGION_RI_REGS         SREGION_RI_REGS         ... EREGION_RI_REGS
#define REGION_SI_REGS         SREGION_SI_REGS         ... EREGION_SI_REGS
#define REGION_UNUSED          SREGION_UNUSED          ... EREGION_UNUSED
#define REGION_CART_2_1        SREGION_CART_2_1        ... EREGION_CART_2_1
#define REGION_CART_1_1        SREGION_CART_1_1        ... EREGION_CART_1_1
#define REGION_CART_2_2        SREGION_CART_2_2        ... EREGION_CART_2_2
#define REGION_CART_1_2        SREGION_CART_1_2        ... EREGION_CART_1_2
// All cartridge regions
#define REGION_CART            SREGION_CART_2_1        ... EREGION_CART_1_2
#define REGION_PIF_BOOT        SREGION_PIF_BOOT        ... EREGION_PIF_BOOT
#define REGION_PIF_RAM         SREGION_PIF_RAM         ... EREGION_PIF_RAM
#define REGION_RESERVED        SREGION_RESERVED        ... EREGION_RESERVED
#define REGION_CART_1_3        SREGION_CART_1_3        ... EREGION_CART_1_3
#define REGION_SYSAD_DEVICE    SREGION_SYSAD_DEVICE    ... EREGION_SYSAD_DEVICE

#define CART_ISVIEWER_FLUSH         0x13FF0014
#define SREGION_CART_ISVIEWER_BUFFER 0x13FF0020
#define EREGION_CART_ISVIEWER_BUFFER 0x13FFFFFF
#define CART_ISVIEWER_SIZE (EREGION_CART_ISVIEWER_BUFFER - SREGION_CART_ISVIEWER_BUFFER)
#define REGION_CART_ISVIEWER_BUFFER SREGION_CART_ISVIEWER_BUFFER ... EREGION_CART_ISVIEWER_BUFFER

#define RSP_SREGION_SP_DMEM 0x000000
#define RSP_SREGION_SP_IMEM 0x001000

#define RSP_REGION_SP_DMEM RSP_SREGION_SP_DMEM ... 0x000FFF
#define RSP_REGION_SP_IMEM RSP_SREGION_SP_IMEM ... 0x001FFF

#define SVREGION_KUSEG 0x00000000
#define SVREGION_KSEG0 0x80000000
#define SVREGION_KSEG1 0xA0000000
#define SVREGION_KSSEG 0xC0000000
#define SVREGION_KSEG3 0xE0000000

#define EVREGION_KUSEG 0x7FFFFFFF
#define EVREGION_KSEG0 0x9FFFFFFF
#define EVREGION_KSEG1 0xBFFFFFFF
#define EVREGION_KSSEG 0xDFFFFFFF
#define EVREGION_KSEG3 0xFFFFFFFF

#define VREGION_KUSEG SVREGION_KUSEG ... EVREGION_KUSEG
#define VREGION_KSEG0 SVREGION_KSEG0 ... EVREGION_KSEG0
#define VREGION_KSEG1 SVREGION_KSEG1 ... EVREGION_KSEG1
#define VREGION_KSSEG SVREGION_KSSEG ... EVREGION_KSSEG
#define VREGION_KSEG3 SVREGION_KSEG3 ... EVREGION_KSEG3

#define VREGION_XKUSEG 0x0000000000000000 ... 0x000000FFFFFFFFFF
#define VREGION_XBAD1  0x0000010000000000 ... 0x3FFFFFFFFFFFFFFF
#define VREGION_XKSSEG 0x4000000000000000 ... 0x400000FFFFFFFFFF
#define VREGION_XBAD2  0x4000010000000000 ... 0x7FFFFFFFFFFFFFFF
#define VREGION_XKPHYS 0x8000000000000000 ... 0xBFFFFFFFFFFFFFFF
#define VREGION_XKSEG  0xC000000000000000 ... 0xC00000FF7FFFFFFF
#define VREGION_XBAD3  0xC00000FF80000000 ... 0xFFFFFFFF7FFFFFFF
#define VREGION_CKSEG0 0xFFFFFFFF80000000 ... 0xFFFFFFFF9FFFFFFF
#define VREGION_CKSEG1 0xFFFFFFFFA0000000 ... 0xFFFFFFFFBFFFFFFF
#define VREGION_CKSSEG 0xFFFFFFFFC0000000 ... 0xFFFFFFFFDFFFFFFF
#define VREGION_CKSEG3 0xFFFFFFFFE0000000 ... 0xFFFFFFFFFFFFFFFF


#define ADDR_RDRAM_CONFIG_REG       0x03F00000
#define ADDR_RDRAM_DEVICE_ID_REG    0x03F00004
#define ADDR_RDRAM_DELAY_REG        0x03F00008
#define ADDR_RDRAM_MODE_REG         0x03F0000C
#define ADDR_RDRAM_REF_INTERVAL_REG 0x03F00010
#define ADDR_RDRAM_REF_ROW_REG      0x03F00014
#define ADDR_RDRAM_RAS_INTERVAL_REG 0x03F00018
#define ADDR_RDRAM_MIN_INTERVAL_REG 0x03F0001C
#define ADDR_RDRAM_ADDR_SELECT_REG  0x03F00020
#define ADDR_RDRAM_DEVICE_MANUF_REG 0x03F00024

#define ADDR_RDRAM_REG_FIRST ADDR_RDRAM_CONFIG_REG
#define ADDR_RDRAM_REG_LAST  ADDR_RDRAM_DEVICE_MANUF_REG


#define ADDR_AI_STATUS_REG 0x0450000C

#define ADDR_PI_DRAM_ADDR_REG    0x04600000
#define ADDR_PI_CART_ADDR_REG    0x04600004
#define ADDR_PI_RD_LEN_REG       0x04600008
#define ADDR_PI_WR_LEN_REG       0x0460000C
#define ADDR_PI_STATUS_REG       0x04600010
#define ADDR_PI_DOMAIN1_REG      0x04600014
#define ADDR_PI_BSD_DOM1_PWD_REG 0x04600018
#define ADDR_PI_BSD_DOM1_PGS_REG 0x0460001C
#define ADDR_PI_BSD_DOM1_RLS_REG 0x04600020
#define ADDR_PI_DOMAIN2_REG      0x04600024
#define ADDR_PI_BSD_DOM2_PWD_REG 0x04600028
#define ADDR_PI_BSD_DOM2_PGS_REG 0x0460002C
#define ADDR_PI_BSD_DOM2_RLS_REG 0x04600030

#define ADDR_RI_MODE_REG    0x04700000
#define ADDR_RI_CONFIG_REG  0x04700004
#define ADDR_RI_SELECT_REG  0x0470000C
#define ADDR_RI_REFRESH_REG 0x04700010
#define ADDR_RI_LATENCY_REG 0x04700014
#define ADDR_RI_RERROR_REG  0x04700018
#define ADDR_RI_WERROR_REG  0x0470001C

#define ADDR_RI_FIRST ADDR_RI_MODE_REG
#define ADDR_RI_LAST  ADDR_RI_WERROR_REG

#define ADDR_MI_MODE_REG      0x04300000
#define ADDR_MI_VERSION_REG   0x04300004
#define ADDR_MI_INTR_REG      0x04300008
#define ADDR_MI_INTR_MASK_REG 0x0430000C

#define ADDR_MI_FIRST ADDR_MI_MODE_REG
#define ADDR_MI_LAST  ADDR_MI_INTR_MASK_REG

#define ADDR_SI_DRAM_ADDR_REG      0x04800000
#define ADDR_SI_PIF_ADDR_RD64B_REG 0x04800004
#define ADDR_SI_UNKNOWN_REG_08     0x04800008
#define ADDR_SI_UNKNOWN_REG_0C     0x0480000C
#define ADDR_SI_PIF_ADDR_WR64B_REG 0x04800010
#define ADDR_SI_UNKNOWN_REG_14     0x04800014
#define ADDR_SI_STATUS_REG         0x04800018
#define ADDR_SI_UNKNOWN_REG_1C     0x0480001C

#define ADDR_AI_DRAM_ADDR_REG 0x04500000
#define ADDR_AI_LEN_REG       0x04500004
#define ADDR_AI_CONTROL_REG   0x04500008
#define ADDR_AI_STATUS_REG    0x0450000C
#define ADDR_AI_DACRATE_REG   0x04500010
#define ADDR_AI_BITRATE_REG   0x04500014

#define ADDR_PIF_RAM_JOYPAD 0x1FC007C4


#endif //N64_ADDRESSES_H
